<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Model;


use Amasty\Geoip\Helper\Data as Helper;
use Exception;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\ResourceConnection;
use Magento\Framework\DB\Select;

class Geolocation extends \Amasty\Geoip\Model\Geolocation
{

    private $request;
    private ScopeConfigInterface $scopeConfig;

    public function __construct(
        Helper $geoipHelper,
        ResourceConnection $resource,
        RequestInterface $request,
        ScopeConfigInterface $scopeConfig
    ) {
        parent::__construct($geoipHelper, $resource);
        $this->request = $request;
        $this->scopeConfig = $scopeConfig;
    }

    /**
     * @param $ip
     * @return $this|Geolocation
     * @throws Exception
     */
    public function locate($ip)
    {
        $country_header_config = $this->scopeConfig->getValue('amgeoipredirect/restriction/geolocation_header');

        if ($this->request->getHeader($country_header_config)) {
            $country = $this->request->getHeader($country_header_config);
            $select = $this->resource->getConnection('read')->select()->from(
                $this->resource->getTableName('amasty_geoip_location')
            )->where('country = ?', $country)->limit(1);

            if ($result = $this->resource->getConnection()->fetchRow($select)) {
                $this->setData($result);
            }
            $this->setData('country', $country);
            return $this;
        }
        return parent::locate($ip); // TODO: Change the autogenerated stub
    }

}
